#include <pthread.h>
#include <semaphore.h>
#include <sys/time.h>

struct osa_mutex_type
{
  sem_t sem ;
  pthread_mutex_t mutex ;
  pthread_cond_t cond ;
  int owned ;
} ;
typedef struct osa_mutex_type osa_mutex_type ;

osa_mutex_type *osa_mutex_create(void) ;
int osa_mutex_give(osa_mutex_type *m) ;
int osa_mutex_take_timed(osa_mutex_type *m, struct timeval *timeout) ;
